/*
	Klasse som kan laste forskjellige type grskala bilder (.jpg, .gif) 
	og bruke dem som hydekart
*/

import java.awt.image.*;
import java.awt.*;

class HeightImageLoader
{
	HeightField hf;
	BufferedImage bi; 
	float level;
	
	//Konstruktr
	public HeightImageLoader(HeightField h)
	{
		hf = h;
		bi = new BufferedImage(hf.getSize(), hf.getSize(), BufferedImage.TYPE_INT_ARGB);
	}

	//Laster bildet inn i et BufferedImage object
	public void loadImage(Image img)
	{
		try 
		{
			bi.getGraphics().drawImage (img, 0, 0, null);
		} catch (Throwable t) { System.out.println("Bildet kunne ikke lastes"); }
		
	}
	
	//Metode som henter pixel verdier fra bildet og lagrer verdien som en
	//hydeverdi i hydekartet
	public void setData(float diff, float level)
	{
		for (int x = 0; x < hf.getSize()-1; x++)
		{
			for (int y = 0; y < hf.getSize()-1; y++)
			{
				/*
					Her hentes pixelverdi ut
					m dele p 2^24 for  f verdi mellom 0 og 1
					diff er variabel for  ke hydeforskjell
					level er variabel for  bestemme hvor p z-akse laveste verdi er
					benyttes for  flytte vannlinje opp og ned
				*/
				float height = (((float)bi.getRGB(x,y)/(float)Math.pow(2,24))*diff)+ (diff+1.0f) + level;	
				//Her settes hydeverdi til hydekartet
				hf.setHeight(x, y, height);
			}
		}
	}

}

