/*
	klasse som beregner normaler p flater
*/

public class Normals
{
	HeightField hf;
	
	//Array til  lagre data fra hydekart
	float[][][] flate;
	
	//Array til  lagre normal data 
	float[][][] normaler;
	
	//Konstruktr
	public Normals(HeightField h)
	{
		hf = h;
		flate = h.getData();
		normaler = new float[h.getSize()][h.getSize()][3];
	}
	
	//Beregner normaler 90 grader vanlig p flate
	public void calcNormals()
	{
		float a[] = new float[3];
		float b[] = new float[3];
		
		for (int x = 1; x < hf.getSize()-2; x++)
		{
			for (int y = 1; y < hf.getSize()-2; y++)
			{
				// make one normal for each strip
				a[0]=flate[x][y+1][0]-flate[x][y][0]; b[0]=flate[x+1][y+1][0]-flate[x][y][0];
				a[1]=flate[x][y+1][1]-flate[x][y][1]; b[1]=flate[x+1][y+1][1]-flate[x][y][1];
				a[2]=flate[x][y+1][2]-flate[x][y][2]; b[2]=flate[x+1][y+1][2]-flate[x][y][2];
		
				normaler[x][y][0] = a[1]*b[2]-a[2]*b[1];
				normaler[x][y][1] = a[2]*b[0]-a[0]*b[2];
				normaler[x][y][2] = a[0]*b[1]-a[1]*b[0];						
			}
		}	
	}

	//Beregner normaler interpolert p flatene
	public void calcInterNormals()
	{
		float a[] = new float[3];
		float b[] = new float[3];
		
		for (int x = 1; x < hf.getSize()-2; x++)
		{
			for (int y = 1; y < hf.getSize()-2; y++)
			{
				// make one normal for each strip
				a[0]=flate[x][y+1][0]-flate[x][y][0]; b[0]=flate[x+1][y+1][0]-flate[x][y][0];
				a[1]=flate[x][y+1][1]-flate[x][y][1]; b[1]=flate[x+1][y+1][1]-flate[x][y][1];
				a[2]=flate[x][y+1][2]-flate[x][y][2]; b[2]=flate[x+1][y+1][2]-flate[x][y][2];
		
				float n1[] = new float[3];
				n1[0] = a[1]*b[2]-a[2]*b[1];
				n1[1] = a[2]*b[0]-a[0]*b[2];
				n1[2] = a[0]*b[1]-a[1]*b[0];

				a[0]=flate[x+1][y-1][0]-flate[x][y][0]; b[0]=flate[x][y-1][0]-flate[x][y][0];
				a[1]=flate[x+1][y-1][1]-flate[x][y][1]; b[1]=flate[x][y-1][1]-flate[x][y][1];
				a[2]=flate[x+1][y-1][2]-flate[x][y][2]; b[2]=flate[x][y-1][2]-flate[x][y][2];
				
				float n2[] = new float[3];
				n2[0] = a[1]*b[2]-a[2]*b[1];
				n2[1] = a[2]*b[0]-a[0]*b[2];
				n2[2] = a[0]*b[1]-a[1]*b[0];

				normaler[x][y][0] = (n1[0]*n2[0])/2.0f;
				normaler[x][y][1] = (n1[1]*n2[1])/2.0f;
				normaler[x][y][2] = (n1[2]*n2[2])/2.0f;						
			}
		}	
	}

	//Henter ut de beregnede normalene 
	public float[][][] getNormals()
	{
		return normaler;
	}

}

