/*
Klasse som generere en himmelsphere,
en halvkule som ligger over terrenget
*/
public class Sphere
{
	//Array til  ta vare p vertex'er for himmelen
	float[][][] sphere = new float[37][37][3];
	
	public void setData(float maxrad, float stride, float area, float maxheight)
	{
		//Strste radius p nederste sirkel
		float rad = ((float)maxrad*stride)/area;
		float tmp = 37.0f;
	
		//Gr igjennom alle punktene i himmelen
		for (int i = 0; i < 37; i++)
		{
			for (int j = 0; j < 37; j++)
			{
				//Genererer strre og strre sirkler 
				//x-verdi
				sphere[i][j][0] = ((float)Math.cos(2*Math.PI*((double)(j*10)/360)))*(float)i/37*rad;
				//y-verdi
				sphere[i][j][1] = ((float)Math.sin(2*Math.PI*((double)(j*10)/360)))*(float)i/37*rad;
				//z-verdi, bytt formel for anderledes bue p halvkulene
				sphere[i][j][2] = (float)Math.log(tmp)*maxheight;
			}
		tmp--;
		}
	
	}

	//Hente ut vertex'er til himmelen
	public float[][][] getSphere() {return sphere;}

	//Hente teksture koordinater til himmelen
	public float[][][] getTextureKoord(float repeat)
	{
		float[][][] text = new float[37][37][2];
		float u = 0.0f;
		float v = 0.0f;
	
		//Hvor mange ganger skal tekstur gjentas
		//Hvis repeat = 1.0, 1 gang, hvis repeat > 1 flere ganger
		float hop = (1.0f/37.0f)*repeat;
	
		for (int i = 0; i < 37; i++)
		{
		
			for (int j = 0; j < 37; j++)
			{
				text[i][j][0] = u;
				text[i][j][1] = v;
			
				u += hop;
			}
			v += hop;
			u = 0.0f;
		
		}
		return text;
	}

}

